## Name

vfs_preopen — Hide read latencies for applications reading numbered files

## Synopsis

`vfs objects = preopen`

## DESCRIPTION

This VFS module is part of the samba(7) suite.

This module assists applications that want to read numbered files in sequence with very strict latency requirements. One area where this happens in video streaming applications that want to read one file per frame.

When you use this module, a number of helper processes is started that speculatively open files and read a number of bytes to prime the file system cache, so that later on when the real application's request comes along, no disk access is necessary.

This module is stackable.

## OPTIONS

preopen:names = /pattern/

  preopen:names specifies the file name pattern which should trigger the preopen helpers to do their work. We assume that the files are numbered incrementally. So if your file names are numbered FRAME00000.frm FRAME00001.frm and so on you would list them as `preopen:names=/FRAME*.frm/`

preopen:num_bytes = BYTES

  Specifies the number of bytes the helpers should speculatively read, defaults to 1.

preopen:helpers = NUM-PROCS

  Number of forked helper processes, defaults to 1.

preopen:queuelen = NUM-FILES

  Number of files that should be speculatively opened. Defaults to the 10 subsequent files.

## VERSION

This man page is correct for version 3.3 of the Samba suite.

## AUTHOR

The original Samba software and related utilities were created by Andrew Tridgell. Samba is now developed by the Samba Team as an Open Source project similar to the way the Linux kernel is developed.

The PREOPEN VFS module was created with contributions from Volker Lendecke and the developers at IBM.